!DIR$ FIXEDFORMLINESIZE:132
      subroutine am_plws_sur_cyl(fail)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      logical*4, intent(out) :: fail

      N1 = Nscth

      nmem = nmem + int8(nword)          ! u
      nmem = nmem + int8(nword)          ! J
      nmem = nmem + int8(N1)*int8(nword) ! I
 
      if(nmem .gt. nmem_tot) then
         write(*,*) '** AM_PLWS_SUR_CYL: Not enough free memory to proceed ***********'
         write(*,*) '** [Required Memory] : ', sngl(nmem*nano)    , ' Gb *************'
         write(*,*) '**  [Allowed Memory] : ', sngl(nmem_tot*nano), ' Gb *************'
         write(*,*) '** NOTE: [Allowed Memory] =/= [Available Memory] ****************'
         write(*,*) '** RECOMENDATION: Check parameters nmem_tot, Nscth'
         fail = .true.
         return
      else
         fail = .false.
      end if

      allocate(uT0D,uR0D)
      uT0D = dzero
      uR0D = dzero
         
      allocate(JT0D,JR0D)
      JT0D = dzero
      JR0D = dzero
 
      allocate(IT1D(1:N1),IR1D(1:N1))
      IT1D = dzero
      IR1D = dzero

      return
      end
