!DIR$ FIXEDFORMLINESIZE:132
      subroutine am_plws_sur_rec(fail)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      logical*4, intent(out) :: fail

      N1 = Nscth
      N2 = Nsphi

      nmem = nmem + int8(nword)                   ! u
      nmem = nmem + int8(3*nword)                 ! J
      nmem = nmem + int8(N1)*int8(N2)*int8(nword) ! I
 
      if(nmem .gt. nmem_tot) then
         write(*,*) '** AM_PLWS_SUR_REC: Not enough free memory to proceed ***********'
         write(*,*) '** [Required Memory] : ', sngl(nmem*nano)    , ' Gb *************'
         write(*,*) '**  [Allowed Memory] : ', sngl(nmem_tot*nano), ' Gb *************'
         write(*,*) '** NOTE: [Allowed Memory] =/= [Available Memory] ****************'
         write(*,*) '** RECOMENDATION: Check parameters nmem_tot, Nscth, Nsphi'
         fail = .true.
         return
      else
         fail = .false.
      end if

      allocate(uT0D,uR0D)
      uT0D = dzero
      uR0D = dzero
         
      allocate(JT1D(1:3),JR1D(1:3))
      JT1D = dzero
      JR1D = dzero
 
      allocate(IT2D(1:N1,1:N2),IR2D(1:N1,1:N2))
      IT2D = dzero
      IR2D = dzero

      return
      end
