      subroutine check_irho(irho, rho, flag)
      use math_blocks
      use rte_blocks
      implicit none

      integer*4, intent(in)    :: irho
      real*4,    intent(out)   :: rho
      logical*4, intent(inout) :: flag

      real*4 rho_of_irho

      if((irho .lt. 1) .or. (irho .gt. lrho)) then
         write(*,*) 'irho0 is outside of range. Try again'
         flag = .true.
      else
         rho = rho_of_irho(irho)
         if(abs(rho) .lt. small) rho = rzero
         write(*,*) 'The corresponding phys. coordinate rho0:', rho
      end if

      return
      end
