!DIR$ FIXEDFORMLINESIZE:132
      subroutine gip_I_3D(ind, iscth, isphi, ix, iy, iz)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: ind
      integer*4, intent(out) :: iscth, isphi, ix, iy, iz

      real*4    scth, sphi, x, y, z
      logical*4 flag  

      iscth = 0
      isphi = 0
      ix    = 0
      iy    = 0
      iz    = 0

      IF((ind .eq. 2) .or. (ind .eq. 3) .or. (ind .eq. 4)) THEN

 101     continue
         write(*,*) 'Give x0, y0, z0 [units of ', Units, ']'
         read(*,*) x, y, z

         flag = .false.
         call check_x(x, ix, flag)
         call check_y(y, iy, flag)
         call check_z(z, iz, flag)
         if(flag) goto 101

      END IF

c--------------------------------------------------------------

      IF((ind .eq. 7) .or. (ind .eq. 9) .or. (ind .eq. 10)) THEN

 102     continue
         write(*,*) 'Give x0 [units of ', Units, ']'
         read(*,*) x
         
         flag = .false.
         call check_x(x, ix, flag)
         if(flag) goto 102

      END IF

c--------------------------------------------------------------

      IF((ind .eq. 6) .or. (ind .eq. 8) .or. (ind .eq. 10)) THEN

 103     continue
         write(*,*) 'Give y0 [units of ', Units, ']'
         read(*,*) y

         flag = .false.
         call check_y(y, iy, flag)
         if(flag) goto 103

      END IF

c--------------------------------------------------------------

      IF((ind .eq. 5) .or. (ind .eq. 8) .or. (ind .eq. 9)) THEN

 104     continue
         write(*,*) 'Give z0 [units of ', Units, ']'
         read(*,*) z

         flag = .false.
         call check_z(z, iz, flag)
         if(flag) goto 104

      END IF

c--------------------------------------------------------------

      IF((ind .ge. 5) .and. (ind .le. 10)) THEN

 105     continue
         write(*,*) 'Give cos(theta0), phi0/pi'
         read(*,*) scth, sphi

         flag = .false.
         call check_scth(scth, iscth, flag)
         call check_sphi(sphi, isphi, flag)
         if(flag) goto 105

      END IF

c--------------------------------------------------------------

      IF(ind .eq. 2) THEN

 106     continue
         write(*,*) 'Give cos(theta0)'
         read(*,*) scth

         flag = .false.
         call check_scth(scth, iscth, flag)
         if(flag) goto 106

      END IF

c--------------------------------------------------------------

      IF(ind .eq. 3) THEN

 107     continue
         write(*,*) 'Give phi0/pi'
         read(*,*) sphi

         flag = .false.
         call check_sphi(sphi, isphi, flag)
         if(flag) goto 107

      END IF

c--------------------------------------------------------------

      return
      end
