!DIR$ FIXEDFORMLINESIZE:132
      subroutine wd_plws_vol_rec()
      use math_blocks
      use rte_blocks
      use header_types
      use file_types
      implicit none

      character*32 name
      real*4 cfc
      logical*4 fail

      integer*4 i1
      real*4 z, z_of_iz

      cfc = weight / (hz*float(nw))

      IF(compute_u) THEN

         u1D = u1D * cfc

         if(Collimated_Source) then
            name = 'u_plwc_vol_rec.asc'
            string%Filetype = ft(7)
         else 
            name = 'u_plwi_vol_rec.bin'
            string%Filetype = ft(7+nft)
         end if

         open(unit=80, file=name, status='unknown')
         do 1, i1=1,L1
         z = z_of_iz(i1)
         write(80,*) z/scale, sngl(u1D(i1))
 1       continue

      END IF


      IF(compute_J) THEN

         J2D = J2D * cfc

         if(Collimated_Source) then
            name = 'J_plwc_vol_rec.asc'
            string%Filetype = ft(19)
         else 
            name = 'J_plwi_vol_rec.bin'
            string%Filetype = ft(19+nft)
         end if

         open(unit=80, file=name, status='unknown')
         do 2, i1=1,L1
         z = z_of_iz(i1)
         write(80,*) z/scale, sngl(J2D(1,i1)), sngl(J2D(2,i1)), sngl(J2D(3,i1))
 2       continue

      END IF



      IF(compute_I) THEN

         I3D = I3D * cfc / (dscth*dsphi)
 3       continue

         if(Collimated_Source) then
            name = 'I_plwc_vol_rec.bin'
            string%Filetype = ft(32)
         else 
            name = 'I_plwi_vol_rec.bin'
            string%Filetype = ft(32+nft)
         end if

         call dump_I_2D_1D(name, I3D, fail)
         if(fail) then
            write(*,*) 'dump_I_2D_1D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 3
         end if
 
      END IF


      return
      end
